const ApiService = Shopware.Classes.ApiService;

class ResChannableConnectorAutoConnectService extends ApiService {
    constructor(httpClient, loginService, apiEndpoint = 'reschannable') {
        super(httpClient, loginService, apiEndpoint);
    }

    getUrl(selectedSalesChannelId, selectedLanguageId, additionalParams = {}, additionalHeaders = {}) {
        const params = additionalParams;
        const headers = this.getBasicHeaders(additionalHeaders);

        return this.httpClient
            .post(`_action/reschannable/get-auto-connect-url`,
                { selectedSalesChannelId, selectedLanguageId },
                { params, headers }
            ).then((response) => {
                return ApiService.handleResponse(response);
            });
    }
}

export default ResChannableConnectorAutoConnectService;
