const { Mixin } = Shopware;
const { debug } = Shopware.Utils;

Mixin.register('res-channableconnector-autoconnect-loader', {

    inject: ['ResChannableConnectorAutoConnectService'],

    computed: {
        onAutoConnectUrl() {
            const params = this.createRequestParameter({
                url: '',
                shop: '',
                version: 'shopware_6',
                username: '',
                api_key: ''
            });

            return `https://app.channable.com/connect/shopware_plugin.html?${params.toString()}`;
        }
    },

    methods: {

        getAutoConnectUrl({ selectedSalesChannelId }) {
            if (this.isLoading) {
                return Promise.resolve(false);
            }

            this.isGetCredentialsSuccessful = null;

            this.isLoading = true;

            return this.ResChannableConnectorAutoConnectService.getUrl(
                selectedSalesChannelId
            ).then((response) => {

            }).catch(() => {

            }).finally(() => {
                this.isLoading = false;
            });
        },

    }
});
