import template from './res-channableconnector-autocon.html.twig';

const { Component, Mixin } = Shopware;

Component.register('res-channableconnector-autocon', {
    template,

    name: 'ResChannableConnectorAutocon',

    mixins: [
        Mixin.getByName('res-channableconnector-autoconnect-loader')
    ],

    props: {
        actualConfigData: {
            type: Object,
            required: true
        },
        allConfigs: {
            type: Object,
            required: true
        },
        selectedSalesChannelId: {
            type: String,
            required: false,
            default: null
        },
        selectedLanguageId: {
            type: String,
            required: false,
            default: null
        },
        isLoading: {
            type: Boolean,
            required: true
        }
    },

    data() {
        return {
            isAutoConnect: false,
            isAutoConnectSuccessful: false
        };
    },

    computed: {
        autoConnectDisabled() {
            return typeof this.$props.selectedSalesChannelId === "undefined" || !this.$props.selectedSalesChannelId
                || typeof this.$props.selectedLanguageId === "undefined" || !this.$props.selectedLanguageId;
        }
    },

    methods: {

        onAutoConnect() {

            this.ResChannableConnectorAutoConnectService.getUrl(
                this.$props.selectedSalesChannelId,
                this.$props.selectedLanguageId
            ).then((response) => {
                window.open(response.url, '_blank');

            }).catch((errorResponse) => {

            });
        }
    }

});