import './components/res-channableconnector-domain';
import './components/res-channableconnector-artconf';
import './components/res-channableconnector-perf';
import './components/res-channableconnector-webhook';
import './components/res-channableconnector-autocon';
import './components/res-channable-settings-icon';
import './page/res-channable-connector';

import deDE from './snippet/de-DE.json';
import enGB from './snippet/en-GB.json';

const { Module } = Shopware;

Module.register('res-channable-connector', {
    type: 'plugin',
    name: 'ResChannableConnector',
    title: 'res-channable-connector.general.mainMenuItemGeneral',
    description: 'res-channable-connector.general.descriptionTextModule',
    version: '1.0.0',
    targetVersion: '1.0.0',
    icon: 'default-action-settings',
    routes: {
        index: {
            component: 'res-channable-connector',
            path: 'index',
            meta: {
                parentPath: 'sw.settings.index'
            }
        }
    },
    snippets: {
        'de-DE': deDE,
        'en-GB': enGB,
    },
    settingsItem: {
        group: 'plugins',
        to: 'res.channable.connector.index',
        iconComponent: 'res-channable-settings-icon',
        backgroundEnabled: false
    }
});