<?php declare(strict_types=1);

namespace Res\ResChannableConnector\Setting\Service\Config;

use Shopware\Core\Framework\DataAbstractionLayer\EntityCollection;

/**
 * @method void                       add(ResChannableConfigEntity $entity)
 * @method void                       set(string $key, ResChannableConfigEntity $entity)
 * @method ResChannableConfigEntity[]    getIterator()
 * @method ResChannableConfigEntity[]    getElements()
 * @method ResChannableConfigEntity|null get(string $key)
 * @method ResChannableConfigEntity|null first()
 * @method ResChannableConfigEntity|null last()
 */
class ResChannableConfigCollection extends EntityCollection
{
    public function getApiAlias(): string
    {
        return 'reschannable_config_collection';
    }

    protected function getExpectedClass(): string
    {
        return ResChannableConfigEntity::class;
    }
}
